MKTHNUM - K-th Number


You are working for Macrohard company in data structures department. After failing your previous task about key insertion you were asked to write a new data structure that would be able to return quickly k-th order statistics in the array segment.

That is, given an array a[1 ... n] of different integer numbers, your program must answer a series of questions Q(i, j, k) in the form: "What would be the k-th number in a[i ... j] segment, if this segment was sorted?"

For example, consider the array a = (1, 5, 2, 6, 3, 7, 4). Let the question be Q(2, 5, 3). The segment a[2 ... 5] is (5, 2, 6, 3). If we sort this segment, we get (2, 3, 5, 6), the third number is 5, and therefore the answer to the question is 5.

Input

The first line of the input contains n — the size of the array, and m — the number of questions to answer (1 ≤ n ≤ 100000, 1 ≤ m ≤ 5000).

The second line contains n different integer numbers not exceeding 10^9 by their absolute values — the array for which the answers should be given.

The following m lines contain question descriptions, each description consists of three numbers: i, j, and k (1 ≤ i ≤ j ≤ n, 1 ≤ k ≤ j - i + 1) and represents the question Q(i, j, k).

Output

For each question output the answer to it — the k-th number in sorted a[i ... j] segment.

Example

Input:
7 3
1 5 2 6 3 7 4
2 5 3
4 4 1
1 7 3

Output:
5
6
3

Note: a naive solution will not work!!!


hide comments
zufius: 2020-02-01 15:09:50

this problem is easier than (& similar) problem COT (use persistent IT to solve)

Last edit: 2020-02-01 15:10:14
fardin_abir: 2019-12-20 09:28:54

solved it on O(log^3 * N).... nice problem...

piasroy071: 2019-10-21 20:11:07

Somehow my solution of merge sort tree with O(log^3 * N) got AC in 1.04s, although the time limit is 0.115s-0.667s. Can someone explain this?
Submissions: https://www.spoj.com/status/MKTHNUM,piasroy071/

zhaopeng: 2019-05-20 12:25:28

Merge Seg + Binary Search + compress(TLE if without), AC.
for each query, many said O(lg^3 N). I believe it's amortized O(lg^2 N). 1(BS) + 1(segment), and should not be another 1, since total size of segments ~ N.

caro_linda2018: 2019-04-26 02:16:28

ACed it in one go :)

Last edit: 2019-04-26 02:17:03
golu20174024: 2019-03-21 03:47:47

use persistent segment tree and i-th order statistics

ab_biswas09: 2019-03-16 20:11:15

Finally AC

kukreja_vlk: 2019-03-09 04:27:35

Any solutions in Java ? Getting TLE after some cases

gormint7777: 2019-03-05 19:21:50

weak test cases!!

nik7: 2019-02-18 06:42:01

@newbie how it can be solved using trie. Can you please explain


Added by:psetter
Date:2009-02-24
Time limit:1s
Source limit:50000B
Memory limit:1536MB
Cluster: Cube (Intel G860)
Languages:All except: ERL JS-RHINO
Resource:Northeastern Europe 2004 Northern Subregion